// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/MonitorReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__MONITOR_REPORT__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__MONITOR_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'FAULT_UNKNOWN'.
/**
  * Fault enumerations
 */
enum
{
  ds_dbw_msgs__msg__MonitorReport__FAULT_UNKNOWN = 0
};

/// Constant 'FAULT_NONE'.
enum
{
  ds_dbw_msgs__msg__MonitorReport__FAULT_NONE = 1
};

/// Constant 'FAULT_FAULT'.
enum
{
  ds_dbw_msgs__msg__MonitorReport__FAULT_FAULT = 2
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/MonitorReport in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__MonitorReport
{
  std_msgs__msg__Header header;
  /// Status
  /// Any fault
  bool fault;
  /// Shutoff due to fault action
  bool shutoff;
  /// Shutoff deferred due to lack of vehicle motion
  bool shutoff_on_motion;
  /// Vehicle is stationary
  bool stationary;
  /// Test fault to verify shutoff action
  uint8_t fault_test;
  /// Aggregate of several faults
  /// Any fault related to system enable/disable
  uint8_t fault_system;
  /// Any fault related to steer control
  uint8_t fault_steer;
  /// Any fault related to brake control
  uint8_t fault_brake;
  /// Any fault related to throttle control
  uint8_t fault_thrtl;
  /// Any fault related to gear control
  uint8_t fault_gear;
  /// Any fault related to the ULC
  uint8_t fault_ulc;
  /// Vehicle velocity measurement mismatch with OEM
  uint8_t fault_vehicle_velocity;
  /// Steer faults
  /// Steering wheel angle measurement mismatch with OEM
  uint8_t fault_steer_feedback;
  /// Steering column torque measurement mismatch with OEM
  uint8_t fault_steer_input;
  /// Steering parameter mismatch with DBW
  uint8_t fault_steer_param;
  /// Steering limit calculation mismatch with DBW
  uint8_t fault_steer_limit;
  /// Steering override calculation mismatch with DBW
  uint8_t fault_steer_override;
  /// Steering actuator command mismatch with OEM and DBW
  uint8_t fault_steer_cmd;
  /// Steering actuator command rate faster than DBW and limit
  uint8_t fault_steer_cmd_rate;
  /// Steering actuator command without matching command enable
  uint8_t fault_steer_cmd_en;
  /// Steering actuator command with system disabled
  uint8_t fault_steer_cmd_sys;
  /// Steering actuator command with override
  uint8_t fault_steer_cmd_ovr;
  /// Brake faults
  /// Brake actuator output torque/pressure measurement mismatch with OEM
  uint8_t fault_brake_feedback;
  /// Brake pedal input torque/pressure measurement mismatch with OEM
  uint8_t fault_brake_input;
  /// Brake parameter mismatch with DBW
  uint8_t fault_brake_param;
  /// Brake limit calculation mismatch with DBW
  uint8_t fault_brake_limit;
  /// Brake override calculation mismatch with DBW
  uint8_t fault_brake_override;
  /// Brake actuator command mismatch with OEM and DBW
  uint8_t fault_brake_cmd;
  /// Brake command generated by ULC command without matching ULC command
  uint8_t fault_brake_cmd_ulc;
  /// Brake actuator command without matching command enable
  uint8_t fault_brake_cmd_en;
  /// Brake actuator command with system disabled
  uint8_t fault_brake_cmd_sys;
  /// Brake actuator command with override
  uint8_t fault_brake_cmd_ovr;
  /// Throttle faults
  /// Accelerator pedal output measurement mismatch with OEM
  uint8_t fault_thrtl_feedback;
  /// Accelerator pedal input measurement mismatch with OEM
  uint8_t fault_thrtl_input;
  /// Throttle parameter mismatch with DBW
  uint8_t fault_thrtl_param;
  /// Throttle limit calculation mismatch with DBW
  uint8_t fault_thrtl_limit;
  /// Throttle override calculation mismatch with DBW
  uint8_t fault_thrtl_override;
  /// Throttle actuator command mismatch with OEM and DBW
  uint8_t fault_thrtl_cmd;
  /// Throttle command generated by ULC command without matching ULC command
  uint8_t fault_thrtl_cmd_ulc;
  /// Throttle actuator command without matching command enable
  uint8_t fault_thrtl_cmd_en;
  /// Throttle actuator command with system disabled
  uint8_t fault_thrtl_cmd_sys;
  /// Throttle actuator command with override
  uint8_t fault_thrtl_cmd_ovr;
  /// Gear faults
  /// Transmission gear measurement mismatch with OEM
  uint8_t fault_gear_feedback;
  /// Gear input selection measurement mismatch with OEM
  uint8_t fault_gear_input;
  /// Gear parameter mismatch with DBW
  uint8_t fault_gear_param;
  /// Gear override calculation mismatch with DBW
  uint8_t fault_gear_override;
  /// Gear actuator command mismatch with OEM and DBW
  uint8_t fault_gear_cmd;
  /// Gear command generated by ULC command without matching ULC command
  uint8_t fault_gear_cmd_ulc;
  /// System faults
  /// System parameter mismatch with DBW
  uint8_t fault_system_param;
  /// Debug
  bool steer_cmd_match_oem;
  bool steer_cmd_match_dbw;
  bool brake_cmd_match_oem;
  bool brake_cmd_match_dbw;
  bool thrtl_cmd_match_oem;
  bool thrtl_cmd_match_dbw;
  bool gear_cmd_match_oem;
  bool gear_cmd_match_dbw;
} ds_dbw_msgs__msg__MonitorReport;

// Struct for a sequence of ds_dbw_msgs__msg__MonitorReport.
typedef struct ds_dbw_msgs__msg__MonitorReport__Sequence
{
  ds_dbw_msgs__msg__MonitorReport * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__MonitorReport__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__MONITOR_REPORT__STRUCT_H_
