// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/SteeringCmd.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__STEERING_CMD__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__STEERING_CMD__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'CMD_NONE'.
/**
  * Command types
  * Command  Rate   Accel    Range        Note
 */
enum
{
  ds_dbw_msgs__msg__SteeringCmd__CMD_NONE = 0
};

/// Constant 'CMD_TORQUE'.
/**
  * Nm       N/A    N/A      <depends>    Torque in Nm
 */
enum
{
  ds_dbw_msgs__msg__SteeringCmd__CMD_TORQUE = 1
};

/// Constant 'CMD_ANGLE'.
/**
  * deg      deg/s  deg/s^2  <depends>    Angle in deg
 */
enum
{
  ds_dbw_msgs__msg__SteeringCmd__CMD_ANGLE = 2
};

/// Constant 'CMD_CURVATURE'.
/**
  * 1/m      deg/s  deg/s^2  -0.2 to 0.2  Curvature in 1/m
 */
enum
{
  ds_dbw_msgs__msg__SteeringCmd__CMD_CURVATURE = 3
};

/// Constant 'CMD_YAW_RATE'.
/**
  * rad/s    deg/s  deg/s^2  -8.5 to 8.5  Yaw rate in rad/s
 */
enum
{
  ds_dbw_msgs__msg__SteeringCmd__CMD_YAW_RATE = 4
};

/// Constant 'CMD_PERCENT'.
/**
  * %        deg/s  deg/s^2  -100 to 100  Percent of max steering wheel angle
 */
enum
{
  ds_dbw_msgs__msg__SteeringCmd__CMD_PERCENT = 14
};

/// Constant 'CMD_CALIBRATE'.
/**
  * deg      N/A    N/A      <depends>    Calibrate current steering wheel angle to value in cmd
 */
enum
{
  ds_dbw_msgs__msg__SteeringCmd__CMD_CALIBRATE = 15
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/SteeringCmd in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__SteeringCmd
{
  std_msgs__msg__Header header;
  /// Steering Wheel
  /// Command, changes with cmd_type
  float cmd;
  /// Rate limit, deg/s, range 0 to 1016, 0 = default, INFINITY = unlimited
  float cmd_rate;
  /// Accel limit, deg/s^2, range 0 to 25400, 0 = default, INFINITY = unlimited
  float cmd_accel;
  uint8_t cmd_type;
  /// Enable
  bool enable;
  /// Clear latched overrides
  bool clear;
  /// Ignore future overrides
  bool ignore;
} ds_dbw_msgs__msg__SteeringCmd;

// Struct for a sequence of ds_dbw_msgs__msg__SteeringCmd.
typedef struct ds_dbw_msgs__msg__SteeringCmd__Sequence
{
  ds_dbw_msgs__msg__SteeringCmd * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__SteeringCmd__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__STEERING_CMD__STRUCT_H_
